unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Grids, StdCtrls, ComCtrls, ExtCtrls, PopupNotifier;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    PopupNotifier1: TPopupNotifier;
    StringGrid1: TStringGrid;
    Timer1: TTimer;
    procedure ausgabe;
    procedure angrenzende;
    procedure minenfeldleeren;
    procedure PopupNotifier1Close(Sender: TObject);
    procedure popupverloren;
    procedure popupgewonnen;
    procedure gewonnen;
    procedure umkreisaufdecken(x,y:integer);
    procedure flaggesetzen(x, y:integer);
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox2Change(Sender: TObject);
    procedure CheckBox3Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end; 

Tfeld=array[0..10,0..10] of string;
Tfeld1=array[0..10,0..10] of boolean;
Tfeld2=array[0..8,0..8] of boolean;

var
  Form1: TForm1;
  minenfeld: Tfeld;
  bombenzahl, flaggenzahl: byte;
  zeit: integer;
  rekursion: Tfeld1;
  aufgedeckt: Tfeld2;

implementation

{ TForm1 }

//CheckBox 1 Schwierigkeit leicht
procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  bombenzahl:=5;

  if CheckBox1.checked=true then
  begin
  checkbox2.visible:=false;
  checkbox3.visible:=false;
  end
  else
  begin
  checkbox2.visible:=true;
  checkbox3.visible:=true
  end;



end;

//CheckBox 2 Schwierigkeit mittel
procedure TForm1.CheckBox2Change(Sender: TObject);
begin
  bombenzahl:=10;
  if CheckBox2.checked=true then
  begin
  checkbox1.visible:=false;
  checkbox3.visible:=false;
  end
  else
  begin
  checkbox1.visible:=true;
  checkbox3.visible:=true
  end;
end;

//CheckBox 3 Schwierigkeit schwer
procedure TForm1.CheckBox3Change(Sender: TObject);
begin
  bombenzahl:=15;
  if CheckBox3.checked=true then
  begin
  checkbox1.visible:=false;
  checkbox2.visible:=false;
  end
  else
  begin
  checkbox1.visible:=true;
  checkbox2.visible:=true
  end;
end;

//Spiel Starten, Feld initialisieren
procedure TForm1.Button1Click(Sender: TObject);
var i,n,k: byte;
begin
  label3.visible:=true;
  label4.caption:='Zu verteilende Flaggen: '+inttostr(bombenzahl);

  //Schwierigkeit bestimmen
  if CheckBox1.checked=true xor CheckBox2.checked=true xor CheckBox3.checked=true  then

  begin
  stringgrid1.visible:=true;
  button1.visible:=false;
  checkbox1.visible:=false;
  checkbox2.visible:=false;
  checkbox3.visible:=false;
  timer1.enabled:=true;
  end;

  //Bomben verteilen
  randomize;
  minenfeldleeren;
  for i:=1 to bombenzahl do
     begin
       k:=random(8)+1;
       n:=random(8)+1;
       if minenfeld[k,n]='*' then
       begin
       while minenfeld[k,n]='*' do
         begin
         k:=random(8)+1;
         n:=random(8)+1;
         end;
         minenfeld[k,n]:='*'
       end

       else minenfeld[k,n]:='*'
    end;

    ausgabe;
    angrenzende;
end;

//Timer
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  zeit:=zeit+1;
  label2.caption:=inttostr(zeit)
end;

//Minenfeld leeren
procedure Tform1.minenfeldleeren;
var i,k: byte;
begin
  for i:=0 to 10 do
   for k:=0 to 10 do
    minenfeld[i,k]:='';
end;

//StringGrid füllen
procedure Tform1.ausgabe;
var z,y:byte;
begin
  for z:=0 to 8 do
    for y:=0 to 8 do
         stringgrid1.cells[z,y]:='█';

  for z:=0 to 10 do
   for y:=0 to 10 do
    aufgedeckt[z,y]:=false;
end;

//Angrenzede Bomben ermitteln
procedure Tform1.angrenzende;
var i,k,q,r,Bzahl: integer;
begin
   Bzahl:=0;
   for i:=1 to 9 do
   for k:=1 to 9 do
       if minenfeld[i,k]<>'*' then begin  bzahl:=0;
                                                 for q:=i-1 to i+1 do
                                                  for r:=k-1 to k+1 do
                                                     begin
                                                        if minenfeld[q,r]='*' then Bzahl:=Bzahl+1;
                                                        if Bzahl<>0 then minenfeld[i,k]:=inttostr(Bzahl);
                                                     end;
                                    end
end;

// Aufdecken
procedure TForm1.StringGrid1MouseDown(Sender: TObject; Button: TMouseButton; X, Y: Integer);
var CellPos:TPoint; i,k: byte;
begin
  CellPos:=StringGrid1.MouseToCell(Point(X,Y));
  for i:=0 to 10 do
   for k:=0 to 10 do
    rekursion[i,k]:=true;

  if Button=mbleft then if stringgrid1.cells[CellPos.X,CellPos.Y]<>'@' then umkreisaufdecken(CellPos.X,CellPos.Y);

  if stringgrid1.cells[CellPos.X,CellPos.Y]='*' then popupverloren;

  if Button=mbright then flaggesetzen(CellPos.X,CellPos.Y);
  gewonnen
end;

//Umkreis aufdecken
procedure Tform1.umkreisaufdecken(x, y:integer);
begin
  if minenfeld[x+1,y+1]<>'' then stringgrid1.cells[x,y]:=minenfeld[x+1,y+1]
                            else if rekursion[x+1,y+1]=true then if stringgrid1.cells[x,y]<>'@' then
                                begin
                                  stringgrid1.cells[x,y]:=minenfeld[x+1,y+1];
                                  rekursion[x+1,y+1]:=false;
                                  aufgedeckt[x,y]:=true;
                                  if x<8 then umkreisaufdecken(x+1,y);
                                  if y<8 then umkreisaufdecken(x,y+1);
                                  if x>0 then umkreisaufdecken(x-1,y);
                                  if y>0 then umkreisaufdecken(x,y-1);
                                  if x<8 then if y<8 then umkreisaufdecken(x+1,y+1);
                                  if x>0 then if y>0 then umkreisaufdecken(x-1,y-1);
                                  if x<8 then if y>0 then umkreisaufdecken(x+1,y-1);
                                  if x>0 then if y<8 then umkreisaufdecken(x-1,y+1);
                                end;

end;

//Verloren PopUp anzeigen
procedure Tform1.popupverloren;
begin
  PopupNotifier1.Text:='Sie haben eine Bombe getroffen!';
  PopupNotifier1.Title:='Verloren';
  PopupNotifier1.ShowAtPos(form1.left+80,form1.top+160);
  timer1.enabled:=false;
  Popupnotifier1.Visible:=true;
end;

//Flagge setzen
procedure Tform1.flaggesetzen(x, y:integer);
begin
  if stringgrid1.cells[x,y]='█' then
    begin
      stringgrid1.cells[x,y]:='@';
      flaggenzahl:=flaggenzahl+1;
    end
     else if stringgrid1.cells[x,y]<>minenfeld[x+1,y+1] then
                                                            begin
                                                              stringgrid1.cells[x,y]:='█';
                                                              flaggenzahl:=flaggenzahl-1;
                                                            end;

  label4.caption:='Zu verteilende Flaggen: '+inttostr(bombenzahl-flaggenzahl);
end;

//Hier wird geprüft, ob das Spiel gewonnen ist
procedure Tform1.gewonnen;
var i,k,ats,quadrate, atsquadrate, aufgedeckt:byte;
begin
  ats:=0;
  quadrate:=0;
  atsquadrate:=0;
  aufgedeckt:=0;
  for i:=0 to 8 do
   for k:=0 to 8 do
    begin
      if stringgrid1.cells[i,k]='█' then quadrate:=quadrate+1;
      if stringgrid1.cells[i,k]='@' then
        if minenfeld[i+1,k+1]='*' then
         ats:=ats+1;
      if stringgrid1.cells[i,k]<>'█' then
        if stringgrid1.cells[i,k]<>'@' then
          aufgedeckt:=aufgedeckt+1;
      if minenfeld[i+1,k+1]='*' then begin
                                       if stringgrid1.cells[i,k]='█' then atsquadrate:=atsquadrate+1;
                                       if stringgrid1.cells[i,k]='@' then atsquadrate:=atsquadrate+1;
                                     end;
    end;
  if ats=bombenzahl then if quadrate=0 then popupgewonnen;
  if 81-aufgedeckt=bombenzahl then if atsquadrate=bombenzahl then popupgewonnen;
end;

//Gewonnen PopUp anzeigen
procedure Tform1.popupgewonnen;
begin
  PopupNotifier1.Text:='Herzlichen Glückwunsch! Sie haben gewonnen! Ihre Zeit: '+label2.caption+' Sekunden';
  PopupNotifier1.Title:='Gewonnen';
  PopupNotifier1.ShowAtPos(form1.left+80,form1.top+160);
  timer1.enabled:=false;
  Popupnotifier1.Visible:=true;
end;

//Zurücksetzen
procedure TForm1.PopupNotifier1Close(Sender: TObject);
begin
  checkbox1.visible:=true;
  checkbox1.Checked:=false;
  checkbox2.visible:=true;
  checkbox2.Checked:=false;
  checkbox3.visible:=true;
  checkbox3.Checked:=false;
  stringgrid1.visible:=false;
  timer1.enabled:=false;
  label2.caption:='';
  Button1.visible:=true;
  flaggenzahl:=0;
  label3.visible:=false;
  label4.caption:='';
  zeit:=0;
end;


initialization

flaggenzahl:=0;


  {$I unit1.lrs}

end.

